package examples.hibernate;

import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;
import org.hibernate.criterion.Order;

import examples.hibernate.domain.*;

public class Example {
    public static void main(String args[]) throws Exception {
	SessionFactory factory = PersistenceUtil.getSessionFactory();
	Session session = factory.getCurrentSession();  // obtain/start unit of work
	Transaction tx = null;
	try {
	    tx = session.beginTransaction();            // start transaction

	    Airplane airplane = new Airplane("Air Force One", 21000, 60, 71, "General Electric");
	    session.save(airplane);
	    session.save(airplane.getEngine());
	    tx.commit();                                // commit transaction & end unit of work
	} catch (RuntimeException ex) {
	    if (tx != null) tx.rollback();              // abort transaction
	    throw ex;
	}

	session = factory.getCurrentSession();  // obtain/start unit of work
	try {
	    tx = session.beginTransaction();            // start transaction
	    // read last airplane
	    Airplane airplane = (Airplane) session.createCriteria(Airplane.class)
						.addOrder( Order.desc("name") )
						.list().get(0);
	    System.out.println(airplane);
	    tx.commit();                                // commit transaction & end unit of work
	} catch (RuntimeException ex) {
	    if (tx != null) tx.rollback();              // abort transaction
	    throw ex;
	}
    }
}
